#Agenda
#Descripcion:Programa en Perl capaz de recibir como entrada registros para una agenda personal. 
#analizar que los campos estn correctamente escritos, y los guarda en un archivo de texto.
#	El primer campo, nombre, deber estar compuesto por solo letras.
#	El segundo campo, telfono, deber estar compuesto por 12 dgitos siguiendo el siguiente formato:55-5555-5555.
#	El tercer campo, correo electrnico, compuesto por  letras, puede ir seguido de  guiones o puntos y mas letras, @ letras y .com

#Fecha:02/09/2013				
#Versin: 1.0
#Autores:Campos Lpez Christian Alex
		#Marron Sanchez Odalys 
        #Reyna Martinez Antonio David 
        #Silva Zaragoza Juan Manuel
#Ejecucin:perl Agenda.pl

#Definicion de funciones
#Funcion "IngresarNombre()"
#Descripcion:Funcion para agregar a la agenda el campo "nombre", validando que el nombre que
#introdusca el usuario tenga solo letras.
#Entrada:ninguna
#Salida: Cadena correspondiente al campo "nombre" del nuevo registro.
#Observaciones:
sub IngresarNombre()
{
	do{
		print "\nIngrese nombre:";
		$nombre=<STDIN>;
		if(!($nombre=~/^[a-zA-Z]+/))#expresion regular para el nombre
		{
			print "\nEl nombre debe comenzar con una letra";
		}
	}while(!($nombre=~/^[a-zA-Z]+/));
	return $nombre;
}

#Funcion "IngresarTelefono()"
#Descripcion:Funcion para agregar a la agenda el campo "telefono", validando que el campo 
#que introdusca el usuario tenga 12 dgitos siguiendo el siguiente formato:55-5555-5555.
#Entrada:ninguna
#Salida: Cadena correspondiente al campo "telefono" del nuevo registro.
sub IngresarTelefono()
{
	do{
		do{
			print "\nIngrese telefono:";
			$telefono=<STDIN>;
			if(length($telefono)!=13)
			{
				print length($telefono);
				print "\nEl numero telefonico debe ser de 12 caracteres";
			}
		}while(length($telefono)!=13);
		if(!($telefono=~/[0-9][0-9]-[0-9][0-9][0-9][0-9]-[0-9][0-9]/))#expresion regular para el telefono
		{
			print "\nEl formato de telefono debe ser 55-5555-5555";
		}
	}while(!($telefono=~/[0-9][0-9]-[0-9][0-9][0-9][0-9]-[0-9][0-9]/));
	return $telefono;
}


#Funcion "IngresarCorreo()"
#Descripcion:Funcion para agregar a la agenda el campo "correo", validando que el campo que 
#introdusca el usuario este compuesto por
# letras, puede ir seguido de  guiones o puntos y mas letras, @ letras y .com
#Entrada:ninguna
#Salida: Cadena correspondiente al campo "correo" del nuevo registro.
#Observaciones:
sub IngresarCorreo()
{
	do{
		print "\nIngrese correo electronico:";
		$correo=<STDIN>;
		if(!($correo=~/^[a-zA-Z]+[0-9]*.*_*@[a-z]+.[a-z]/))#expresion regular para el correo electronico
		{
			print("\nEl formato de correo es incorrecto:\nEl correo debe iniciar con letras puede seguirlo guion bajo o punto, seguido por @, cadena de letras minusculas, punto y cadena de minusculas.");
		}
	}while(!($correo=~/^[a-zA-Z]+[0-9]*.*_*@[a-z]+.[a-z]/));	
	return $correo;
}

#Funcion "IngresarDatos()"
#Descripcion:Funcion para captura en agenda los tres campos para un nuevo registro, haciendo uso de las funciones anteriores, y los
#agrega a un archivo de texto existente.
#Entrada:ninguna
#Salida: ninguna
#Observaciones:	de no existir el archivo donde se guardaran los registros el programa creara uno nuevo.
sub IngresarDatos()
{	
	print "Desea cambiar archivo de agenda (S/N):";
	$opcion=<STDIN>;
	lc($opcion);
	if($opcion eq "s")
	{
		print "\nIngrese la direccion del archivo donde desea guardar los datos:";
		$direccion=<STDIN>;
	}
	else
	{
		$direccion="Agenda.txt";
	}
	open (Archivo,">>$direccion") || die "ERROR: No puedo abrir el fichero $direccion\n";
	$nombre=IngresarNombre();
	$telefono=IngresarTelefono();
	$correo=IngresarCorreo();	
	print Archivo "$nombre";
	print Archivo "$telefono";
	print Archivo "$correo";
	close(Archivo);
}
#Funcion "MostrarDatos()"
#Descripcion:Funcion que muestra en pantalla los registros existentes en la agenda personal desde el archivo
#Entrada:ninguna
#Salida: ninguna
#Observaciones:	

sub MostrarDatos()
{
	print "\nDesea cambiar archivo de agenda (S/N)";
	$opcion=<STDIN>;
	lc($opcion);
	if($opcion eq "s")
	{
		print "\nIngrese la direccion del archivo que desea leer:";
		$direccion=<STDIN>;
	}
	else
	{
		$direccion="Agenda.txt";
	}
	open (Archivo,$direccion) || die "ERROR: No puedo abrir el fichero $direccion\n";
	print "\nRegistros existentes:\n";
	while (<Archivo>)
	{
	   print $_;
	}
	close(Archivo);
}

#Programa principal
do{
	print "=====Registro de datos en agenda====\n";
	IngresarDatos();
	print "\nRegistro exitoso";
	MostrarDatos();
	print "\nDesea salir:(S/N):";
	$salir=<STDIN>;
	lc($salir);
}while($salir eq "n");

